#include <inttypes.h>
#include <threads.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>

#include <librace.h>

#include "mpmc-queue.h"

void threadA(struct mpmc_boundq_1_alt<int32_t, 2> *queue)
{
	int32_t *bin;
	bin = queue->write_prepare();
	if (bin) {
		*bin = 1;
		printf("write_bin %d, val %d\n", bin, 1);
		queue->write_publish(bin);
	} else {
		printf("write failed\n");
	}
}

void threadB(struct mpmc_boundq_1_alt<int32_t, 2> *queue)
{
	int32_t *bin;
	bin = queue->read_fetch();
	if (bin) {
		printf("read_bin: %d, val %d\n", bin, *bin);
		queue->read_consume(bin);
	} else {
		printf("Read failed\n");
	}
}

int user_main(int argc, char **argv)
{
	struct mpmc_boundq_1_alt<int32_t, 2> queue;
	thrd_t A, B;

	printf("Adding initial element\n");
	int32_t *bin;
	bin = queue.write_prepare();
	*bin = 17;
	printf("init_write_bin %d, val %d\n", bin, 17);
	queue.write_publish(bin);

	bin = queue.write_prepare();
	*bin = 27;
	printf("init_write_bin %d, val %d\n", bin, 27);
	queue.write_publish(bin);


	printf("Start threads\n");

	thrd_create(&A, (thrd_start_t)&threadA, &queue);
	thrd_create(&B, (thrd_start_t)&threadB, &queue);

	thrd_join(A);
	thrd_join(B);
	printf("Threads complete\n");

	return 0;
}
